var StorageNameEnum;
(function (StorageNameEnum) {
    StorageNameEnum["FCM_LOCAL_"] = "FCM_LOCAL_";
})(StorageNameEnum || (StorageNameEnum = {}));
var StorageLocalKeyEnum;
(function (StorageLocalKeyEnum) {
    StorageLocalKeyEnum["FCM_APPS"] = "FCM_APPS";
})(StorageLocalKeyEnum || (StorageLocalKeyEnum = {}));
class StorageLocal {
    constructor() {
        this.cache = new Map();
    }
    get(storageLocalKeyEnum) {
        const key = StorageNameEnum.FCM_LOCAL_ + storageLocalKeyEnum;
        let fromCache = this.cache.get(key);
        if (!!fromCache === false) {
            const value = localStorage.getItem(key);
            if (value == null || value === 'undefined' || value === undefined || value == '') {
                return null;
            }
            try {
                fromCache = JSON.parse(value);
            }
            catch (e) {
                fromCache = undefined;
                console.error('StorageLocalService need to refactor: ', e);
            }
            this.cache.set(key, fromCache);
        }
        return fromCache;
    }
    set(storageLocalKeyEnum, value) {
        const key = StorageNameEnum.FCM_LOCAL_ + storageLocalKeyEnum;
        this.cache.set(key, value);
        localStorage.setItem(key, JSON.stringify(value));
    }
    remove(storageLocalKeyEnum) {
        const key = StorageNameEnum.FCM_LOCAL_ + storageLocalKeyEnum;
        this.cache.delete(key);
        localStorage.removeItem(key);
    }
    removeAll() {
        this.cache.clear();
        const arr = []; // Array to hold the keys
        // Iterate over localStorage and insert the keys that meet the condition into arr
        for (let i = 0; i < localStorage.length; i++) {
            if (localStorage.key(i).substring(0, StorageNameEnum.FCM_LOCAL_.length) === StorageNameEnum.FCM_LOCAL_) {
                arr.push(localStorage.key(i));
            }
        }
        // Iterate over arr and remove the items by key
        // tslint:disable-next-line:prefer-for-of
        arr.forEach((item) => {
            localStorage.removeItem(item);
        });
    }
    setFCMApps(value) {
        this.set(StorageLocalKeyEnum.FCM_APPS, value);
    }
    getFCMApps() {
        return this.get(StorageLocalKeyEnum.FCM_APPS) || [];
    }
}
export class FileStream {
    constructor() {
    }
    readStorage() {
        return FileStream.storageLocal.getFCMApps();
    }
    writeEmpty() {
        FileStream.storageLocal.setFCMApps([]);
    }
    writeStorage(firebaseConfig) {
        let firebaseConfigs = FileStream.storageLocal.getFCMApps();
        firebaseConfigs = firebaseConfigs
            .filter(config => {
            return config.firebaseAppName !== firebaseConfig.firebaseAppName;
        })
            .filter(config => {
            return config.projectId !== firebaseConfig.projectId;
        });
        firebaseConfigs.push(firebaseConfig);
        FileStream.storageLocal.setFCMApps(firebaseConfigs);
    }
}
FileStream.storageLocal = new StorageLocal();
//# sourceMappingURL=FileStream.js.map